#ifndef LOCK_CLIENT_PROTOCOL_H
#define LOCK_CLIENT_PROTOCOL_H

#ifdef  __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

struct wl_client;
struct wl_resource;

struct lock;
struct wl_output;
struct wl_surface;

extern const struct wl_interface lock_interface;

#define LOCK_SET_LOCK_SURFACE	0
#define LOCK_UNLOCK	1

#define LOCK_SET_LOCK_SURFACE_SINCE_VERSION	1
#define LOCK_UNLOCK_SINCE_VERSION	1

static inline void
lock_set_user_data(struct lock *lock, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) lock, user_data);
}

static inline void *
lock_get_user_data(struct lock *lock)
{
	return wl_proxy_get_user_data((struct wl_proxy *) lock);
}

static inline uint32_t
lock_get_version(struct lock *lock)
{
	return wl_proxy_get_version((struct wl_proxy *) lock);
}

static inline void
lock_destroy(struct lock *lock)
{
	wl_proxy_destroy((struct wl_proxy *) lock);
}

static inline void
lock_set_lock_surface(struct lock *lock, struct wl_output *output, struct wl_surface *surface)
{
	wl_proxy_marshal((struct wl_proxy *) lock,
			 LOCK_SET_LOCK_SURFACE, output, surface);
}

static inline void
lock_unlock(struct lock *lock)
{
	wl_proxy_marshal((struct wl_proxy *) lock,
			 LOCK_UNLOCK);
}

#ifdef  __cplusplus
}
#endif

#endif
