#ifndef LOCK_SERVER_PROTOCOL_H
#define LOCK_SERVER_PROTOCOL_H

#ifdef  __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

struct wl_client;
struct wl_resource;

struct lock;
struct wl_output;
struct wl_surface;

extern const struct wl_interface lock_interface;

/**
 * lock - create lock screen UIs
 * @set_lock_surface: (none)
 * @unlock: (none)
 *
 * The Weston desktop-shell protocol's locking functionality depends more
 * on the behavior of the compositor than of a screen locking client, so
 * another protocol is necessary.
 */
struct lock_interface {
	/**
	 * set_lock_surface - (none)
	 * @output: (none)
	 * @surface: (none)
	 */
	void (*set_lock_surface)(struct wl_client *client,
				 struct wl_resource *resource,
				 struct wl_resource *output,
				 struct wl_resource *surface);
	/**
	 * unlock - (none)
	 */
	void (*unlock)(struct wl_client *client,
		       struct wl_resource *resource);
};


#ifdef  __cplusplus
}
#endif

#endif
